#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#ifdef _DCC
#define __inline
#endif

#include "Speak.h"
#include "SpeakStrings_cat.h"

extern char* GetString(int);

char *GetMBString(int ref)
{
	char *aux;

	aux = GetString(ref);
	if (aux[1] == '\0') return(&aux[0]);
	else                return(aux);
}

struct ObjApp * CreateApp(void)
{
	struct ObjApp * Object;

	APTR	MN_label_0Projekt, MN_label_0Quit, MN_label_1Projekt, MN_label_1About;
	APTR	MN_label_1Quit, GROUP_ROOT_0, GR_grp_0, GR_grp_12, GR_grp_10, GR_grp_3;
	APTR	GR_grp_3CC, GR_grp_6, obj_aux0, obj_aux1, GROUP_ROOT_1;

	if (!(Object = AllocVec(sizeof(struct ObjApp), MEMF_PUBLIC|MEMF_CLEAR)))
		return(NULL);

	Object->STR_TX_label_0 = GetMBString(MSG_TX_label_0);
	Object->STR_TX_label_1 = GetMBString(MSG_TX_label_1);
	Object->STR_TX_label_4CC = GetMBString(MSG_TX_label_4CC);
	Object->STR_TX_label_2 = GetMBString(MSG_TX_label_2);
	Object->STR_TX_label_3 = GetMBString(MSG_TX_label_3);
	Object->STR_TX_label_4 = GetMBString(MSG_TX_label_4);
	Object->STR_TX_label_5 = GetMBString(MSG_TX_label_5);
	Object->STR_TX_label_6 = GetMBString(MSG_TX_label_6);
	Object->STR_TX_F1ADJ = GetMBString(MSG_TX_F1ADJ);
	Object->STR_TX_F2ADJ = GetMBString(MSG_TX_F2ADJ);
	Object->STR_TX_F3ADJ = GetMBString(MSG_TX_F3ADJ);
	Object->STR_TX_A1ADJ = GetMBString(MSG_TX_A1ADJ);
	Object->STR_TX_A2ADJ = GetMBString(MSG_TX_A2ADJ);
	Object->STR_TX_A3ADJ = GetMBString(MSG_TX_A3ADJ);
	Object->STR_TX_ARTIC = GetMBString(MSG_TX_ARTIC);
	Object->STR_TX_AVBIAS = GetMBString(MSG_TX_AVBIAS);
	Object->STR_TX_AFBIAS = GetMBString(MSG_TX_AFBIAS);
	Object->STR_TX_CENT = GetMBString(MSG_TX_CENT);
	Object->STR_TX_PHONEME = NULL;
	Object->STR_TX_label_7 = GetMBString(MSG_TX_label_7);

	Object->CY_SEXContent[0] = GetMBString(MSG_CY_SEX0);
	Object->CY_SEXContent[1] = GetMBString(MSG_CY_SEX1);
	Object->CY_SEXContent[2] = NULL;
	Object->CY_KINDContent[0] = GetMBString(MSG_CY_KIND0);
	Object->CY_KINDContent[1] = GetMBString(MSG_CY_KIND1);
	Object->CY_KINDContent[2] = GetMBString(MSG_CY_KIND2);
	Object->CY_KINDContent[3] = NULL;
	Object->CY_OUTPUTContent[0] = GetMBString(MSG_CY_OUTPUT0);
	Object->CY_OUTPUTContent[1] = GetMBString(MSG_CY_OUTPUT1);
	Object->CY_OUTPUTContent[2] = GetMBString(MSG_CY_OUTPUT2);
	Object->CY_OUTPUTContent[3] = NULL;
	Object->STR_GR_grp_10[0] = GetMBString(MSG_GR_grp_100);
	Object->STR_GR_grp_10[1] = GetMBString(MSG_GR_grp_101);
	Object->STR_GR_grp_10[2] = NULL;

	Object->TX_label_0 = TextObject,
		MUIA_HelpNode, "TX_label_0",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_0,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->CY_SEX = CycleObject,
		MUIA_HelpNode, "CY_SEX",
		MUIA_Cycle_Entries, Object->CY_SEXContent,
	End;

	Object->TX_label_1 = TextObject,
		MUIA_HelpNode, "TX_label_1",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_1,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->CY_KIND = CycleObject,
		MUIA_HelpNode, "CY_KIND",
		MUIA_Cycle_Entries, Object->CY_KINDContent,
	End;

	Object->TX_label_4CC = TextObject,
		MUIA_HelpNode, "TX_label_4CC",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_4CC,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->CY_OUTPUT = CycleObject,
		MUIA_HelpNode, "CY_OUTPUT",
		MUIA_Cycle_Entries, Object->CY_OUTPUTContent,
	End;

	Object->TX_label_2 = TextObject,
		MUIA_HelpNode, "TX_label_2",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_2,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_HEIGHT = SliderObject,
		MUIA_HelpNode, "SL_HEIGHT",
		MUIA_Slider_Min, 65,
		MUIA_Slider_Max, 320,
		MUIA_Slider_Level, 150,
	End;

	Object->TX_label_3 = TextObject,
		MUIA_HelpNode, "TX_label_3",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_3,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_SPEED = SliderObject,
		MUIA_HelpNode, "SL_SPEED",
		MUIA_Slider_Min, 40,
		MUIA_Slider_Max, 400,
		MUIA_Slider_Level, 100,
	End;

	Object->TX_label_4 = TextObject,
		MUIA_HelpNode, "TX_label_4",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_4,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_VOLUME = SliderObject,
		MUIA_HelpNode, "SL_VOLUME",
		MUIA_Slider_Min, 0,
		MUIA_Slider_Max, 64,
		MUIA_Slider_Level, 64,
	End;

	GR_grp_0 = GroupObject,
		MUIA_Frame, MUIV_Frame_Group,
		MUIA_FrameTitle, GetMBString(MSG_GR_grp_0Title),
		MUIA_Group_Columns, 2,
		Child, Object->TX_label_0,
		Child, Object->CY_SEX,
		Child, Object->TX_label_1,
		Child, Object->CY_KIND,
		Child, Object->TX_label_4CC,
		Child, Object->CY_OUTPUT,
		Child, Object->TX_label_2,
		Child, Object->SL_HEIGHT,
		Child, Object->TX_label_3,
		Child, Object->SL_SPEED,
		Child, Object->TX_label_4,
		Child, Object->SL_VOLUME,
	End;

	Object->TX_label_5 = TextObject,
		MUIA_HelpNode, "TX_label_5",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_5,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_ENTHUSIASMUS = SliderObject,
		MUIA_HelpNode, "SL_ENTHUSIASMUS",
		MUIA_Slider_Min, 0,
		MUIA_Slider_Max, 255,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_label_6 = TextObject,
		MUIA_HelpNode, "TX_label_6",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_label_6,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_PERTUBATION = SliderObject,
		MUIA_HelpNode, "SL_PERTUBATION",
		MUIA_Slider_Min, 0,
		MUIA_Slider_Max, 255,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_F1ADJ = TextObject,
		MUIA_HelpNode, "TX_F1ADJ",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_F1ADJ,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_F1ADJ = SliderObject,
		MUIA_HelpNode, "SL_F1ADJ",
		MUIA_Slider_Min, -100,
		MUIA_Slider_Max, 100,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_F2ADJ = TextObject,
		MUIA_HelpNode, "TX_F2ADJ",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_F2ADJ,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_F2ADJ = SliderObject,
		MUIA_HelpNode, "SL_F2ADJ",
		MUIA_Slider_Min, -100,
		MUIA_Slider_Max, 100,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_F3ADJ = TextObject,
		MUIA_HelpNode, "TX_F3ADJ",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_F3ADJ,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_F3ADJ = SliderObject,
		MUIA_HelpNode, "SL_F3ADJ",
		MUIA_Slider_Min, -100,
		MUIA_Slider_Max, 100,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_A1ADJ = TextObject,
		MUIA_HelpNode, "TX_A1ADJ",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_A1ADJ,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_A1ADJ = SliderObject,
		MUIA_HelpNode, "SL_A1ADJ",
		MUIA_Slider_Min, -31,
		MUIA_Slider_Max, 32,
		MUIA_Slider_Level, 0,
	End;

	GR_grp_3 = GroupObject,
		MUIA_Group_Columns, 2,
		Child, Object->TX_label_5,
		Child, Object->SL_ENTHUSIASMUS,
		Child, Object->TX_label_6,
		Child, Object->SL_PERTUBATION,
		Child, Object->TX_F1ADJ,
		Child, Object->SL_F1ADJ,
		Child, Object->TX_F2ADJ,
		Child, Object->SL_F2ADJ,
		Child, Object->TX_F3ADJ,
		Child, Object->SL_F3ADJ,
		Child, Object->TX_A1ADJ,
		Child, Object->SL_A1ADJ,
	End;

	Object->TX_A2ADJ = TextObject,
		MUIA_HelpNode, "TX_A2ADJ",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_A2ADJ,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_A2ADJ = SliderObject,
		MUIA_HelpNode, "SL_A2ADJ",
		MUIA_Slider_Min, -31,
		MUIA_Slider_Max, 32,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_A3ADJ = TextObject,
		MUIA_HelpNode, "TX_A3ADJ",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_A3ADJ,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_A3ADJ = SliderObject,
		MUIA_HelpNode, "SL_A3ADJ",
		MUIA_Slider_Min, -31,
		MUIA_Slider_Max, 32,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_ARTIC = TextObject,
		MUIA_HelpNode, "TX_ARTIC",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_ARTIC,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_ARTIC = SliderObject,
		MUIA_HelpNode, "SL_ARTIC",
		MUIA_Slider_Min, 0,
		MUIA_Slider_Max, 400,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_AVBIAS = TextObject,
		MUIA_HelpNode, "TX_AVBIAS",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_AVBIAS,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_AVBIAS = SliderObject,
		MUIA_HelpNode, "SL_AVBIAS",
		MUIA_Slider_Min, -31,
		MUIA_Slider_Max, 32,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_AFBIAS = TextObject,
		MUIA_HelpNode, "TX_AFBIAS",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_AFBIAS,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_AFBIAS = SliderObject,
		MUIA_HelpNode, "SL_AFBIAS",
		MUIA_Slider_Min, -31,
		MUIA_Slider_Max, 32,
		MUIA_Slider_Level, 0,
	End;

	Object->TX_CENT = TextObject,
		MUIA_HelpNode, "TX_CENT",
		MUIA_Background, MUII_BACKGROUND,
		MUIA_Text_Contents, Object->STR_TX_CENT,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->SL_CENT = SliderObject,
		MUIA_HelpNode, "SL_CENT",
		MUIA_Slider_Min, 0,
		MUIA_Slider_Max, 100,
		MUIA_Slider_Level, 0,
	End;

	GR_grp_3CC = GroupObject,
		MUIA_Group_Columns, 2,
		Child, Object->TX_A2ADJ,
		Child, Object->SL_A2ADJ,
		Child, Object->TX_A3ADJ,
		Child, Object->SL_A3ADJ,
		Child, Object->TX_ARTIC,
		Child, Object->SL_ARTIC,
		Child, Object->TX_AVBIAS,
		Child, Object->SL_AVBIAS,
		Child, Object->TX_AFBIAS,
		Child, Object->SL_AFBIAS,
		Child, Object->TX_CENT,
		Child, Object->SL_CENT,
	End;

	GR_grp_10 = RegisterObject,
		MUIA_Register_Titles, Object->STR_GR_grp_10,
		MUIA_HelpNode, "GR_grp_10",
		MUIA_Frame, MUIV_Frame_Group,
		Child, GR_grp_3,
		Child, GR_grp_3CC,
	End;

	Object->STR_TEXT = StringObject,
		MUIA_Frame, MUIV_Frame_String,
		MUIA_HelpNode, "STR_TEXT",
		MUIA_String_MaxLen, 255,
	End;

	obj_aux1 = Label2(GetMBString(MSG_STR_TEXT));

	obj_aux0 = GroupObject,
		MUIA_Group_Columns, 2,
		Child, obj_aux1,
		Child, Object->STR_TEXT,
	End;

	Object->TX_PHONEME = TextObject,
		MUIA_Frame, MUIV_Frame_Text,
		MUIA_Text_Contents, Object->STR_TX_PHONEME,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->BT_SPEAK = SimpleButton(GetMBString(MSG_BT_SPEAK));

	GR_grp_6 = GroupObject,
		Child, obj_aux0,
		Child, Object->TX_PHONEME,
		Child, Object->BT_SPEAK,
	End;

	GR_grp_12 = GroupObject,
		MUIA_HelpNode, "GR_grp_12",
		MUIA_Frame, MUIV_Frame_Group,
		Child, GR_grp_10,
		Child, GR_grp_6,
	End;

	GROUP_ROOT_0 = GroupObject,
		Child, GR_grp_0,
		Child, GR_grp_12,
	End;

	MN_label_1About = MenuitemObject,
		MUIA_Menuitem_Title, GetMBString(MSG_MN_label_1About),
		MUIA_Menuitem_Shortcut, GetMBString(MSG_MN_label_1AboutChar),
	End;

	MN_label_1Quit = MenuitemObject,
		MUIA_Menuitem_Title, GetMBString(MSG_MN_label_1Quit),
		MUIA_Menuitem_Shortcut, GetMBString(MSG_MN_label_1QuitChar),
	End;

	MN_label_1Projekt = MenuObject,
		MUIA_Menu_Title, GetMBString(MSG_MN_label_1Projekt),
		MUIA_Family_Child, MN_label_1About,
		MUIA_Family_Child, MN_label_1Quit,
	End;

	Object->MN_label_1 = MenustripObject,
		MUIA_Family_Child, MN_label_1Projekt,
	End;

	Object->WIN_Main = WindowObject,
		MUIA_Window_Title, GetMBString(MSG_WIN_Main),
		MUIA_HelpNode, "WIN_Main",
		MUIA_Window_Menustrip, Object->MN_label_1,
		MUIA_Window_ID, MAKE_ID('0', 'W', 'I', 'N'),
		WindowContents, GROUP_ROOT_0,
	End;

	Object->TX_label_7 = TextObject,
		MUIA_Background, MUII_HSHINEBACK,
		MUIA_Text_Contents, Object->STR_TX_label_7,
		MUIA_Text_SetMin, TRUE,
	End;

	Object->BT_OK = SimpleButton(GetMBString(MSG_BT_OK));

	GROUP_ROOT_1 = GroupObject,
		Child, Object->TX_label_7,
		Child, Object->BT_OK,
	End;

	Object->WIN_About = WindowObject,
		MUIA_Window_Title, GetMBString(MSG_WIN_About),
		MUIA_Window_ID, MAKE_ID('1', 'W', 'I', 'N'),
		MUIA_Window_SizeGadget, FALSE,
		WindowContents, GROUP_ROOT_1,
	End;

	MN_label_0Quit = MenuitemObject,
		MUIA_Menuitem_Title, GetMBString(MSG_MN_label_0Quit),
		MUIA_Menuitem_Shortcut, GetMBString(MSG_MN_label_0QuitChar),
	End;

	MN_label_0Projekt = MenuObject,
		MUIA_Menu_Title, GetMBString(MSG_MN_label_0Projekt),
		MUIA_Family_Child, MN_label_0Quit,
	End;

	Object->MN_label_0 = MenustripObject,
		MUIA_Family_Child, MN_label_0Projekt,
	End;

	Object->App = ApplicationObject,
		MUIA_Application_Author, "Andreas Jung, Klosterstr. 21, D-66125 Saarbrcken, Germany",
		MUIA_Application_Menustrip, Object->MN_label_0,
		MUIA_Application_Base, "MUISPEAK",
		MUIA_Application_Title, "MUI Speak",
		MUIA_Application_Version, "$VER: MuiSpeak 0.03 (06.10.94)",
		MUIA_Application_Copyright, GetMBString(MSG_AppCopyright),
		MUIA_Application_Description, GetMBString(MSG_AppDescription),
		SubWindow, Object->WIN_Main,
		SubWindow, Object->WIN_About,
	End;


	if (!Object->App)
	{
		FreeVec(Object);
		return(NULL);
	}

	DoMethod(MN_label_0Quit,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit
		);

	DoMethod(MN_label_1About,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		Object->WIN_About,
		3,
		MUIM_Set, MUIA_Window_Open, TRUE
		);

	DoMethod(MN_label_1Quit,
		MUIM_Notify, MUIA_Menuitem_Trigger, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit
		);

	DoMethod(Object->WIN_Main,
		MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
		Object->App,
		2,
		MUIM_Application_ReturnID, MUIV_Application_ReturnID_Quit
		);

	DoMethod(Object->CY_SEX,
		MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_SEX
		);

	DoMethod(Object->CY_KIND,
		MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_KIND
		);

	DoMethod(Object->CY_OUTPUT,
		MUIM_Notify, MUIA_Cycle_Active, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_OUTPUT
		);

	DoMethod(Object->SL_HEIGHT,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_HEIGHT
		);

	DoMethod(Object->SL_SPEED,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_SPEED
		);

	DoMethod(Object->SL_VOLUME,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_VOLUME
		);

	DoMethod(Object->SL_ENTHUSIASMUS,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_ENTHU
		);

	DoMethod(Object->SL_PERTUBATION,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_PERTUB
		);

	DoMethod(Object->SL_F1ADJ,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_F1ADJ
		);

	DoMethod(Object->SL_F2ADJ,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_F2ADJ
		);

	DoMethod(Object->SL_F3ADJ,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_F3ADJ
		);

	DoMethod(Object->SL_A1ADJ,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_A1ADJ
		);

	DoMethod(Object->SL_A2ADJ,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_A2ADJ
		);

	DoMethod(Object->SL_A3ADJ,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_A3ADJ
		);

	DoMethod(Object->SL_ARTIC,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_ARTIC
		);

	DoMethod(Object->SL_AVBIAS,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_AVBIAS
		);

	DoMethod(Object->SL_AFBIAS,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_AFBIAS
		);

	DoMethod(Object->SL_CENT,
		MUIM_Notify, MUIA_Slider_Level, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_CENT
		);

	DoMethod(Object->STR_TEXT,
		MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_TEXT
		);

	DoMethod(Object->BT_SPEAK,
		MUIM_Notify, MUIA_Pressed, TRUE,
		Object->App,
		2,
		MUIM_Application_ReturnID, RET_SPEAK
		);

	DoMethod(Object->WIN_Main,
		MUIM_Window_SetCycleChain, Object->TX_label_0,
		Object->CY_SEX,
		Object->TX_label_1,
		Object->CY_KIND,
		Object->TX_label_4CC,
		Object->CY_OUTPUT,
		Object->TX_label_2,
		Object->SL_HEIGHT,
		Object->TX_label_3,
		Object->SL_SPEED,
		Object->TX_label_4,
		Object->SL_VOLUME,
		Object->TX_label_5,
		Object->SL_ENTHUSIASMUS,
		Object->TX_label_6,
		Object->SL_PERTUBATION,
		Object->TX_F1ADJ,
		Object->SL_F1ADJ,
		Object->TX_F2ADJ,
		Object->SL_F2ADJ,
		Object->TX_F3ADJ,
		Object->SL_F3ADJ,
		Object->TX_A1ADJ,
		Object->SL_A1ADJ,
		Object->TX_A2ADJ,
		Object->SL_A2ADJ,
		Object->TX_A3ADJ,
		Object->SL_A3ADJ,
		Object->TX_ARTIC,
		Object->SL_ARTIC,
		Object->TX_AVBIAS,
		Object->SL_AVBIAS,
		Object->TX_AFBIAS,
		Object->SL_AFBIAS,
		Object->TX_CENT,
		Object->SL_CENT,
		Object->STR_TEXT,
		Object->TX_PHONEME,
		Object->BT_SPEAK,
		0
		);

	DoMethod(Object->WIN_About,
		MUIM_Notify, MUIA_Window_CloseRequest, TRUE,
		Object->WIN_About,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(Object->BT_OK,
		MUIM_Notify, MUIA_Pressed, TRUE,
		Object->WIN_About,
		3,
		MUIM_Set, MUIA_Window_Open, FALSE
		);

	DoMethod(Object->WIN_About,
		MUIM_Window_SetCycleChain, Object->TX_label_7,
		Object->BT_OK,
		0
		);

	set(Object->WIN_Main,
		MUIA_Window_Open, TRUE
		);


	return(Object);
}

void DisposeApp(struct ObjApp * Object)
{
	MUI_DisposeObject(Object->App);
	FreeVec(Object);
}
